/* DEVICES */
#define SYSDEV 0
#define KVDDEV 64
#define DCEDEV 128
#define DTEDEV 256
#define PRTDEV 384
#define DSKDEV 448
#define MOUDEV 512
#define RTCDEV 576
#define SPRTDEV 640
#define DCONDEV 704
#define SCONDEV 768

/* OPCODES */
#define RESET 0
#define FORMAT 4
#define GSTATRG 4
#define GSTATUS 8
#define SSTATUS 12
#define READ 16
#define WRITE 20
#define FRDPHYS 24
#define RDFLUSH 24
#define WRFLUSH 28

/*ERROR CODES */
#define NOERR 0
#define BADCALL 1
#define DEAD 2
#define ILLDEV 3
#define ILLOPC 4
#define NOTRDY 5
#define WRFLT 6
#define RDFLT 7
#define OUTPAP 8
#define NOSCTR 9
#define NOTRK 10
#define ILLFRMT 11
#define WRPRT 12
#define CRCERR 13
#define DEVOVR 14
#define ECCERR 15
#define FRAMERR 16
#define PARERR 17
#define TIMOUT 18
#define STRTNF 19
#define ENDNF 20

/*OPTIONS*/
#define STRIP 1
#define WAIT 2
#define GENATTRI 20
#define STRING 0xc0
#define BLOCK 0x80

/*disk driver get status*/

#define MEDCHK 0
#define CTRLOG 2
#define GNUMDRV 4
#define GOSMAP 6
#define TDKCHK 8

/*disk driver set status*/

#define MEDSET 0
#define DRVMAP 2
#define SNUMDRV 4
#define SOSMAP 6
#define XEBECS 8
#define XEBECI 10
#define MSGDUMP 12
#define TMOC 14
/*GIFT DATA AREA STRUCTURE*/
struct	giftd {
	int	device;
	int	options;
	int	ral;
	int	rdi;
	int	rcx;
	int	rdx;
	int	res;
	int	rsi;
};
